/**
  Generated Main Source File

  Company:
    Microchip Technology Inc.

  File Name:
    main.c

  Summary:
    This is the main file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  Description:
    This header file provides implementations for driver APIs for all modules selected in the GUI.
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.76
        Device            :  PIC18F45K22
        Driver Version    :  2.00
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#include "mcc_generated_files/mcc.h"
#include "APP2025_LCD_XC8/APP2025_LCD.H"


void    BZ_Action_Initial(unsigned char, unsigned int, unsigned int) ;

unsigned char   Display_No = 0 ;
unsigned char   Display_Table[16] = {   0x3f, 0x06, 0x5b, 0x4f, 0x66, 0x6d, 0x7d, 0x07, 
                                                     0x7f, 0x6f, 0x77, 0x7c, 0x39, 0x5e, 0x79, 0x71};

unsigned char   Time_Minute, Time_Second, Time_Hour ;
unsigned int    Time_Tick = 0 ;
unsigned char  LED_Value = 0x01, LED_Direction = 0, LED_Shift_Timer = 0 ;
unsigned char   LCD_REFRESH_FLAG = 0 ;
unsigned char   BZ_ON= 1 ;

unsigned int        ADC_ReadValue= 0 ;
unsigned int        BZ_Timer = 0 ;
unsigned int        BZ_Action_Buffer[16];
unsigned char       BZ_Action_Count = 0 ;
unsigned char       BZ_Action_Index  = 0 ;

unsigned int    LED_Shift_Limit = 25 ;

#define     SECOND_TICK     250 
#define     LED_SHIFT_TIME 25
#define     BZ_TIMER_LIMIT 500
/*
                         Main application
 */

struct {
        unsigned char Disp1 ;
        unsigned char Disp2 ;
        unsigned char Disp3 ;
        unsigned char Disp4 ;
        unsigned char LEDs ;
    }  Display_Buffer;

void    All_COM_Off(void) 
{
    COM_1_SetLow();
    COM_2_SetLow() ;
    COM_3_SetLow() ;
    COM_4_SetLow();
    COM_5_SetLow(); 
}

void My_T1_ISR(void)
{
    

    if (BZ_ON)
    {
        BZ_Timer ++ ;
            if ( BZ_Timer >= BZ_Action_Buffer[BZ_Action_Index])
            {
                BZ_Timer = 0 ;
                BZ_Action_Index ++ ;
                if (BZ_Action_Index >= BZ_Action_Count )
                {
                    EPWM1_LoadDutyValue(0) ;
                    BZ_Action_Index = 0 ;
                    BZ_ON = 0 ;
                }
                else
                {
                    if (BZ_Action_Index %2)              
                        EPWM1_LoadDutyValue(0) ; 
                    else
                        EPWM1_LoadDutyValue(128) ; 
                }
            }
    }
    Time_Tick ++ ;
    if ( Time_Tick >= SECOND_TICK )
    {
        //  Check SW1 & SW2 
                if ( !SW1_RB0_GetValue())
                {
                    BZ_Action_Initial (2,20,20) ;
                    if (LED_Shift_Limit < 50)
                        LED_Shift_Limit += 5 ;
                }

                if ( ! SW2_RA4_GetValue())
                 {
                    BZ_Action_Initial (2,20,20) ;
                    if (LED_Shift_Limit > 10)
                        LED_Shift_Limit -= 5;
                }               
        
        Time_Tick = 0 ;
        Time_Second ++ ;
        if ( Time_Second >= 60)
        {
            Time_Second = 0 ;
            Time_Minute ++ ;
            if (Time_Minute >= 60)
            {
                Time_Minute = 0 ;
                Time_Hour ++ ;
                if (Time_Hour >= 12 )
                    Time_Hour = 0 ;
            }
        }
    }
    
    LED_Shift_Timer ++ ;
    
    if ( LED_Shift_Timer >= LED_Shift_Limit)
    {
        LED3_RC1_Toggle() ;
        LCD_REFRESH_FLAG = 1 ;
        LED_Shift_Timer = 0 ;
                    if (LED_Direction == 0)
            {
                LED_Value = LED_Value << 1 ;
                if (LED_Value == 0x80 ) LED_Direction = 1 ;
            }
            else
            {
                LED_Value = LED_Value >> 1 ;
                if (LED_Value == 0x01 ) LED_Direction = 0 ;
            }
    
    }
    
    switch (Display_No)
    {
        case 0:
            All_COM_Off() ;
            LATD = Display_Table[ Display_Buffer.Disp1] ;
            COM_1_SetHigh() ;
            Display_No ++ ;
            break ;
        case 1:
             All_COM_Off() ;
            LATD =Display_Table[ Display_Buffer.Disp2] ;
            COM_2_SetHigh() ;
            Display_No ++ ;           
           break ;
        case 2 :
             All_COM_Off() ;
            LATD = Display_Table[Display_Buffer.Disp3 ] ;
            COM_3_SetHigh() ;
            Display_No ++ ;           
            break ;
        case 3:
            All_COM_Off() ;
            LATD = Display_Table[Display_Buffer.Disp4 ] ;
            COM_4_SetHigh() ;
            Display_No ++ ;
            break ;
            
          case 4:
            All_COM_Off() ;
            LATD = LED_Value ;
            COM_5_SetHigh() ;
            Display_No = 0  ;
            break ;
        default :
            break ;
    }
}

void    BZ_Action_Initial(unsigned char Beep_Count, unsigned int ON_Time, unsigned int OFF_Time)
{
    unsigned BZ_Init_Loop ;
    BZ_Action_Index = 0 ;
    BZ_Action_Count = Beep_Count * 2  ;
    BZ_Timer = 0 ;
            for ( BZ_Init_Loop = 0 ; BZ_Init_Loop < BZ_Action_Count  ; BZ_Init_Loop += 2)
            {
                BZ_Action_Buffer[BZ_Init_Loop]= ON_Time ;
                BZ_Action_Buffer[BZ_Init_Loop +1]= OFF_Time ;
            }
    EPWM1_LoadDutyValue(128) ; 
    BZ_ON = 1 ;
}

void main(void)
{
    // Initialize the device
    SYSTEM_Initialize();

    // If using interrupts in PIC18 High/Low Priority Mode you need to enable the Global High and Low Interrupts
    // If using interrupts in PIC Mid-Range Compatibility Mode you need to enable the Global and Peripheral Interrupts
    // Use the following macros to:

    TMR1_SetInterruptHandler( My_T1_ISR);          // Setting Timer1 interrupt handler
    Display_No = 0 ;
    Time_Minute = 0 ;
    Time_Second = 0 ;
    Time_Hour = 0 ; 
 
    BZ_Action_Initial (2,50,50) ;       // 2 beeps , ON = 50 * 4 ms , OFF = 50*4 ms
    
     openLCD( ) ;
     
     putrsLCD( "I AM APP2025" ) ;
     setCursorLCD(0,1) ;
      putrsLCD( "TIME=  :  :  " ) ;    
     
    // Enable the Global Interrupts
    INTERRUPT_GlobalInterruptEnable();

    // Disable the Global Interrupts
    //INTERRUPT_GlobalInterruptDisable();

    // Enable the Peripheral Interrupts
    INTERRUPT_PeripheralInterruptEnable();

    // Disable the Peripheral Interrupts
    //INTERRUPT_PeripheralInterruptDisable();

    
    while (1)
    {
        // Add your application code
        if (LCD_REFRESH_FLAG )
        {
            setCursorLCD(5,1) ;
            putNumberLCD( Time_Hour , 2 ) ;
            
            setCursorLCD(8,1) ;
            putNumberLCD( Time_Minute , 2 ) ;
            
            setCursorLCD(11,1) ;
            putNumberLCD( Time_Second , 2 ) ;
            
            LCD_REFRESH_FLAG = 0 ;
            
                ADC_SelectChannel(VR1_AN0) ;
                ADC_StartConversion() ;
                while( !ADC_IsConversionDone()) 
                { }
                
                ADC_ReadValue = ADC_GetConversionResult();
                if (BZ_ON == 0 )
                {
                    if (ADC_ReadValue > 1000)
                         BZ_Action_Initial (2,10,10) ;
                    
                    else if (ADC_ReadValue > 900)
                         BZ_Action_Initial (2,20,20) ;
                 
                    else if (ADC_ReadValue > 800)
                         BZ_Action_Initial (2,50,50) ; 
                }

                    Display_Buffer.Disp1=ADC_ReadValue/1000;
                    ADC_ReadValue %= 1000;
                    Display_Buffer.Disp2=ADC_ReadValue/100;
                    ADC_ReadValue %= 100;
                    Display_Buffer.Disp3=ADC_ReadValue/10;
                    ADC_ReadValue %= 10;
                    Display_Buffer.Disp4 = ADC_ReadValue ;
        }
    }
}
/**
 End of File
*/