/**
  @Generated Pin Manager Header File

  @Company:
    Microchip Technology Inc.

  @File Name:
    pin_manager.h

  @Summary:
    This is the Pin Manager file generated using PIC10 / PIC12 / PIC16 / PIC18 MCUs

  @Description
    This header file provides APIs for driver for .
    Generation Information :
        Product Revision  :  PIC10 / PIC12 / PIC16 / PIC18 MCUs - 1.76
        Device            :  PIC18F45K22
        Driver Version    :  2.11
    The generated drivers are tested against the following:
        Compiler          :  XC8 2.00
        MPLAB 	          :  MPLAB X 5.10	
*/

/*
    (c) 2018 Microchip Technology Inc. and its subsidiaries. 
    
    Subject to your compliance with these terms, you may use Microchip software and any 
    derivatives exclusively with Microchip products. It is your responsibility to comply with third party 
    license terms applicable to your use of third party software (including open source software) that 
    may accompany Microchip software.
    
    THIS SOFTWARE IS SUPPLIED BY MICROCHIP "AS IS". NO WARRANTIES, WHETHER 
    EXPRESS, IMPLIED OR STATUTORY, APPLY TO THIS SOFTWARE, INCLUDING ANY 
    IMPLIED WARRANTIES OF NON-INFRINGEMENT, MERCHANTABILITY, AND FITNESS 
    FOR A PARTICULAR PURPOSE.
    
    IN NO EVENT WILL MICROCHIP BE LIABLE FOR ANY INDIRECT, SPECIAL, PUNITIVE, 
    INCIDENTAL OR CONSEQUENTIAL LOSS, DAMAGE, COST OR EXPENSE OF ANY KIND 
    WHATSOEVER RELATED TO THE SOFTWARE, HOWEVER CAUSED, EVEN IF MICROCHIP 
    HAS BEEN ADVISED OF THE POSSIBILITY OR THE DAMAGES ARE FORESEEABLE. TO 
    THE FULLEST EXTENT ALLOWED BY LAW, MICROCHIP'S TOTAL LIABILITY ON ALL 
    CLAIMS IN ANY WAY RELATED TO THIS SOFTWARE WILL NOT EXCEED THE AMOUNT 
    OF FEES, IF ANY, THAT YOU HAVE PAID DIRECTLY TO MICROCHIP FOR THIS 
    SOFTWARE.
*/

#ifndef PIN_MANAGER_H
#define PIN_MANAGER_H

/**
  Section: Included Files
*/

#include <xc.h>

#define INPUT   1
#define OUTPUT  0

#define HIGH    1
#define LOW     0

#define ANALOG      1
#define DIGITAL     0

#define PULL_UP_ENABLED      1
#define PULL_UP_DISABLED     0

// get/set VR1_AN0 aliases
#define VR1_AN0_TRIS                 TRISAbits.TRISA0
#define VR1_AN0_LAT                  LATAbits.LATA0
#define VR1_AN0_PORT                 PORTAbits.RA0
#define VR1_AN0_ANS                  ANSELAbits.ANSA0
#define VR1_AN0_SetHigh()            do { LATAbits.LATA0 = 1; } while(0)
#define VR1_AN0_SetLow()             do { LATAbits.LATA0 = 0; } while(0)
#define VR1_AN0_Toggle()             do { LATAbits.LATA0 = ~LATAbits.LATA0; } while(0)
#define VR1_AN0_GetValue()           PORTAbits.RA0
#define VR1_AN0_SetDigitalInput()    do { TRISAbits.TRISA0 = 1; } while(0)
#define VR1_AN0_SetDigitalOutput()   do { TRISAbits.TRISA0 = 0; } while(0)
#define VR1_AN0_SetAnalogMode()      do { ANSELAbits.ANSA0 = 1; } while(0)
#define VR1_AN0_SetDigitalMode()     do { ANSELAbits.ANSA0 = 0; } while(0)

// get/set SW2_RA4 aliases
#define SW2_RA4_TRIS                 TRISAbits.TRISA4
#define SW2_RA4_LAT                  LATAbits.LATA4
#define SW2_RA4_PORT                 PORTAbits.RA4
#define SW2_RA4_SetHigh()            do { LATAbits.LATA4 = 1; } while(0)
#define SW2_RA4_SetLow()             do { LATAbits.LATA4 = 0; } while(0)
#define SW2_RA4_Toggle()             do { LATAbits.LATA4 = ~LATAbits.LATA4; } while(0)
#define SW2_RA4_GetValue()           PORTAbits.RA4
#define SW2_RA4_SetDigitalInput()    do { TRISAbits.TRISA4 = 1; } while(0)
#define SW2_RA4_SetDigitalOutput()   do { TRISAbits.TRISA4 = 0; } while(0)

// get/set SW1_RB0 aliases
#define SW1_RB0_TRIS                 TRISBbits.TRISB0
#define SW1_RB0_LAT                  LATBbits.LATB0
#define SW1_RB0_PORT                 PORTBbits.RB0
#define SW1_RB0_WPU                  WPUBbits.WPUB0
#define SW1_RB0_ANS                  ANSELBbits.ANSB0
#define SW1_RB0_SetHigh()            do { LATBbits.LATB0 = 1; } while(0)
#define SW1_RB0_SetLow()             do { LATBbits.LATB0 = 0; } while(0)
#define SW1_RB0_Toggle()             do { LATBbits.LATB0 = ~LATBbits.LATB0; } while(0)
#define SW1_RB0_GetValue()           PORTBbits.RB0
#define SW1_RB0_SetDigitalInput()    do { TRISBbits.TRISB0 = 1; } while(0)
#define SW1_RB0_SetDigitalOutput()   do { TRISBbits.TRISB0 = 0; } while(0)
#define SW1_RB0_SetPullup()          do { WPUBbits.WPUB0 = 1; } while(0)
#define SW1_RB0_ResetPullup()        do { WPUBbits.WPUB0 = 0; } while(0)
#define SW1_RB0_SetAnalogMode()      do { ANSELBbits.ANSB0 = 1; } while(0)
#define SW1_RB0_SetDigitalMode()     do { ANSELBbits.ANSB0 = 0; } while(0)

// get/set COM_1 aliases
#define COM_1_TRIS                 TRISBbits.TRISB2
#define COM_1_LAT                  LATBbits.LATB2
#define COM_1_PORT                 PORTBbits.RB2
#define COM_1_WPU                  WPUBbits.WPUB2
#define COM_1_ANS                  ANSELBbits.ANSB2
#define COM_1_SetHigh()            do { LATBbits.LATB2 = 1; } while(0)
#define COM_1_SetLow()             do { LATBbits.LATB2 = 0; } while(0)
#define COM_1_Toggle()             do { LATBbits.LATB2 = ~LATBbits.LATB2; } while(0)
#define COM_1_GetValue()           PORTBbits.RB2
#define COM_1_SetDigitalInput()    do { TRISBbits.TRISB2 = 1; } while(0)
#define COM_1_SetDigitalOutput()   do { TRISBbits.TRISB2 = 0; } while(0)
#define COM_1_SetPullup()          do { WPUBbits.WPUB2 = 1; } while(0)
#define COM_1_ResetPullup()        do { WPUBbits.WPUB2 = 0; } while(0)
#define COM_1_SetAnalogMode()      do { ANSELBbits.ANSB2 = 1; } while(0)
#define COM_1_SetDigitalMode()     do { ANSELBbits.ANSB2 = 0; } while(0)

// get/set COM_2 aliases
#define COM_2_TRIS                 TRISBbits.TRISB3
#define COM_2_LAT                  LATBbits.LATB3
#define COM_2_PORT                 PORTBbits.RB3
#define COM_2_WPU                  WPUBbits.WPUB3
#define COM_2_ANS                  ANSELBbits.ANSB3
#define COM_2_SetHigh()            do { LATBbits.LATB3 = 1; } while(0)
#define COM_2_SetLow()             do { LATBbits.LATB3 = 0; } while(0)
#define COM_2_Toggle()             do { LATBbits.LATB3 = ~LATBbits.LATB3; } while(0)
#define COM_2_GetValue()           PORTBbits.RB3
#define COM_2_SetDigitalInput()    do { TRISBbits.TRISB3 = 1; } while(0)
#define COM_2_SetDigitalOutput()   do { TRISBbits.TRISB3 = 0; } while(0)
#define COM_2_SetPullup()          do { WPUBbits.WPUB3 = 1; } while(0)
#define COM_2_ResetPullup()        do { WPUBbits.WPUB3 = 0; } while(0)
#define COM_2_SetAnalogMode()      do { ANSELBbits.ANSB3 = 1; } while(0)
#define COM_2_SetDigitalMode()     do { ANSELBbits.ANSB3 = 0; } while(0)

// get/set COM_3 aliases
#define COM_3_TRIS                 TRISBbits.TRISB4
#define COM_3_LAT                  LATBbits.LATB4
#define COM_3_PORT                 PORTBbits.RB4
#define COM_3_WPU                  WPUBbits.WPUB4
#define COM_3_ANS                  ANSELBbits.ANSB4
#define COM_3_SetHigh()            do { LATBbits.LATB4 = 1; } while(0)
#define COM_3_SetLow()             do { LATBbits.LATB4 = 0; } while(0)
#define COM_3_Toggle()             do { LATBbits.LATB4 = ~LATBbits.LATB4; } while(0)
#define COM_3_GetValue()           PORTBbits.RB4
#define COM_3_SetDigitalInput()    do { TRISBbits.TRISB4 = 1; } while(0)
#define COM_3_SetDigitalOutput()   do { TRISBbits.TRISB4 = 0; } while(0)
#define COM_3_SetPullup()          do { WPUBbits.WPUB4 = 1; } while(0)
#define COM_3_ResetPullup()        do { WPUBbits.WPUB4 = 0; } while(0)
#define COM_3_SetAnalogMode()      do { ANSELBbits.ANSB4 = 1; } while(0)
#define COM_3_SetDigitalMode()     do { ANSELBbits.ANSB4 = 0; } while(0)

// get/set COM_4 aliases
#define COM_4_TRIS                 TRISBbits.TRISB5
#define COM_4_LAT                  LATBbits.LATB5
#define COM_4_PORT                 PORTBbits.RB5
#define COM_4_WPU                  WPUBbits.WPUB5
#define COM_4_ANS                  ANSELBbits.ANSB5
#define COM_4_SetHigh()            do { LATBbits.LATB5 = 1; } while(0)
#define COM_4_SetLow()             do { LATBbits.LATB5 = 0; } while(0)
#define COM_4_Toggle()             do { LATBbits.LATB5 = ~LATBbits.LATB5; } while(0)
#define COM_4_GetValue()           PORTBbits.RB5
#define COM_4_SetDigitalInput()    do { TRISBbits.TRISB5 = 1; } while(0)
#define COM_4_SetDigitalOutput()   do { TRISBbits.TRISB5 = 0; } while(0)
#define COM_4_SetPullup()          do { WPUBbits.WPUB5 = 1; } while(0)
#define COM_4_ResetPullup()        do { WPUBbits.WPUB5 = 0; } while(0)
#define COM_4_SetAnalogMode()      do { ANSELBbits.ANSB5 = 1; } while(0)
#define COM_4_SetDigitalMode()     do { ANSELBbits.ANSB5 = 0; } while(0)

// get/set COM_5 aliases
#define COM_5_TRIS                 TRISCbits.TRISC0
#define COM_5_LAT                  LATCbits.LATC0
#define COM_5_PORT                 PORTCbits.RC0
#define COM_5_SetHigh()            do { LATCbits.LATC0 = 1; } while(0)
#define COM_5_SetLow()             do { LATCbits.LATC0 = 0; } while(0)
#define COM_5_Toggle()             do { LATCbits.LATC0 = ~LATCbits.LATC0; } while(0)
#define COM_5_GetValue()           PORTCbits.RC0
#define COM_5_SetDigitalInput()    do { TRISCbits.TRISC0 = 1; } while(0)
#define COM_5_SetDigitalOutput()   do { TRISCbits.TRISC0 = 0; } while(0)

// get/set LED3_RC1 aliases
#define LED3_RC1_TRIS                 TRISCbits.TRISC1
#define LED3_RC1_LAT                  LATCbits.LATC1
#define LED3_RC1_PORT                 PORTCbits.RC1
#define LED3_RC1_SetHigh()            do { LATCbits.LATC1 = 1; } while(0)
#define LED3_RC1_SetLow()             do { LATCbits.LATC1 = 0; } while(0)
#define LED3_RC1_Toggle()             do { LATCbits.LATC1 = ~LATCbits.LATC1; } while(0)
#define LED3_RC1_GetValue()           PORTCbits.RC1
#define LED3_RC1_SetDigitalInput()    do { TRISCbits.TRISC1 = 1; } while(0)
#define LED3_RC1_SetDigitalOutput()   do { TRISCbits.TRISC1 = 0; } while(0)

// get/set RC2 procedures
#define RC2_SetHigh()            do { LATCbits.LATC2 = 1; } while(0)
#define RC2_SetLow()             do { LATCbits.LATC2 = 0; } while(0)
#define RC2_Toggle()             do { LATCbits.LATC2 = ~LATCbits.LATC2; } while(0)
#define RC2_GetValue()              PORTCbits.RC2
#define RC2_SetDigitalInput()    do { TRISCbits.TRISC2 = 1; } while(0)
#define RC2_SetDigitalOutput()   do { TRISCbits.TRISC2 = 0; } while(0)
#define RC2_SetAnalogMode()         do { ANSELCbits.ANSC2 = 1; } while(0)
#define RC2_SetDigitalMode()        do { ANSELCbits.ANSC2 = 0; } while(0)

// get/set IO_RD0 aliases
#define IO_RD0_TRIS                 TRISDbits.TRISD0
#define IO_RD0_LAT                  LATDbits.LATD0
#define IO_RD0_PORT                 PORTDbits.RD0
#define IO_RD0_ANS                  ANSELDbits.ANSD0
#define IO_RD0_SetHigh()            do { LATDbits.LATD0 = 1; } while(0)
#define IO_RD0_SetLow()             do { LATDbits.LATD0 = 0; } while(0)
#define IO_RD0_Toggle()             do { LATDbits.LATD0 = ~LATDbits.LATD0; } while(0)
#define IO_RD0_GetValue()           PORTDbits.RD0
#define IO_RD0_SetDigitalInput()    do { TRISDbits.TRISD0 = 1; } while(0)
#define IO_RD0_SetDigitalOutput()   do { TRISDbits.TRISD0 = 0; } while(0)
#define IO_RD0_SetAnalogMode()      do { ANSELDbits.ANSD0 = 1; } while(0)
#define IO_RD0_SetDigitalMode()     do { ANSELDbits.ANSD0 = 0; } while(0)

// get/set IO_RD1 aliases
#define IO_RD1_TRIS                 TRISDbits.TRISD1
#define IO_RD1_LAT                  LATDbits.LATD1
#define IO_RD1_PORT                 PORTDbits.RD1
#define IO_RD1_ANS                  ANSELDbits.ANSD1
#define IO_RD1_SetHigh()            do { LATDbits.LATD1 = 1; } while(0)
#define IO_RD1_SetLow()             do { LATDbits.LATD1 = 0; } while(0)
#define IO_RD1_Toggle()             do { LATDbits.LATD1 = ~LATDbits.LATD1; } while(0)
#define IO_RD1_GetValue()           PORTDbits.RD1
#define IO_RD1_SetDigitalInput()    do { TRISDbits.TRISD1 = 1; } while(0)
#define IO_RD1_SetDigitalOutput()   do { TRISDbits.TRISD1 = 0; } while(0)
#define IO_RD1_SetAnalogMode()      do { ANSELDbits.ANSD1 = 1; } while(0)
#define IO_RD1_SetDigitalMode()     do { ANSELDbits.ANSD1 = 0; } while(0)

// get/set IO_RD2 aliases
#define IO_RD2_TRIS                 TRISDbits.TRISD2
#define IO_RD2_LAT                  LATDbits.LATD2
#define IO_RD2_PORT                 PORTDbits.RD2
#define IO_RD2_ANS                  ANSELDbits.ANSD2
#define IO_RD2_SetHigh()            do { LATDbits.LATD2 = 1; } while(0)
#define IO_RD2_SetLow()             do { LATDbits.LATD2 = 0; } while(0)
#define IO_RD2_Toggle()             do { LATDbits.LATD2 = ~LATDbits.LATD2; } while(0)
#define IO_RD2_GetValue()           PORTDbits.RD2
#define IO_RD2_SetDigitalInput()    do { TRISDbits.TRISD2 = 1; } while(0)
#define IO_RD2_SetDigitalOutput()   do { TRISDbits.TRISD2 = 0; } while(0)
#define IO_RD2_SetAnalogMode()      do { ANSELDbits.ANSD2 = 1; } while(0)
#define IO_RD2_SetDigitalMode()     do { ANSELDbits.ANSD2 = 0; } while(0)

// get/set IO_RD3 aliases
#define IO_RD3_TRIS                 TRISDbits.TRISD3
#define IO_RD3_LAT                  LATDbits.LATD3
#define IO_RD3_PORT                 PORTDbits.RD3
#define IO_RD3_ANS                  ANSELDbits.ANSD3
#define IO_RD3_SetHigh()            do { LATDbits.LATD3 = 1; } while(0)
#define IO_RD3_SetLow()             do { LATDbits.LATD3 = 0; } while(0)
#define IO_RD3_Toggle()             do { LATDbits.LATD3 = ~LATDbits.LATD3; } while(0)
#define IO_RD3_GetValue()           PORTDbits.RD3
#define IO_RD3_SetDigitalInput()    do { TRISDbits.TRISD3 = 1; } while(0)
#define IO_RD3_SetDigitalOutput()   do { TRISDbits.TRISD3 = 0; } while(0)
#define IO_RD3_SetAnalogMode()      do { ANSELDbits.ANSD3 = 1; } while(0)
#define IO_RD3_SetDigitalMode()     do { ANSELDbits.ANSD3 = 0; } while(0)

// get/set IO_RD4 aliases
#define IO_RD4_TRIS                 TRISDbits.TRISD4
#define IO_RD4_LAT                  LATDbits.LATD4
#define IO_RD4_PORT                 PORTDbits.RD4
#define IO_RD4_ANS                  ANSELDbits.ANSD4
#define IO_RD4_SetHigh()            do { LATDbits.LATD4 = 1; } while(0)
#define IO_RD4_SetLow()             do { LATDbits.LATD4 = 0; } while(0)
#define IO_RD4_Toggle()             do { LATDbits.LATD4 = ~LATDbits.LATD4; } while(0)
#define IO_RD4_GetValue()           PORTDbits.RD4
#define IO_RD4_SetDigitalInput()    do { TRISDbits.TRISD4 = 1; } while(0)
#define IO_RD4_SetDigitalOutput()   do { TRISDbits.TRISD4 = 0; } while(0)
#define IO_RD4_SetAnalogMode()      do { ANSELDbits.ANSD4 = 1; } while(0)
#define IO_RD4_SetDigitalMode()     do { ANSELDbits.ANSD4 = 0; } while(0)

// get/set IO_RD5 aliases
#define IO_RD5_TRIS                 TRISDbits.TRISD5
#define IO_RD5_LAT                  LATDbits.LATD5
#define IO_RD5_PORT                 PORTDbits.RD5
#define IO_RD5_ANS                  ANSELDbits.ANSD5
#define IO_RD5_SetHigh()            do { LATDbits.LATD5 = 1; } while(0)
#define IO_RD5_SetLow()             do { LATDbits.LATD5 = 0; } while(0)
#define IO_RD5_Toggle()             do { LATDbits.LATD5 = ~LATDbits.LATD5; } while(0)
#define IO_RD5_GetValue()           PORTDbits.RD5
#define IO_RD5_SetDigitalInput()    do { TRISDbits.TRISD5 = 1; } while(0)
#define IO_RD5_SetDigitalOutput()   do { TRISDbits.TRISD5 = 0; } while(0)
#define IO_RD5_SetAnalogMode()      do { ANSELDbits.ANSD5 = 1; } while(0)
#define IO_RD5_SetDigitalMode()     do { ANSELDbits.ANSD5 = 0; } while(0)

// get/set IO_RD6 aliases
#define IO_RD6_TRIS                 TRISDbits.TRISD6
#define IO_RD6_LAT                  LATDbits.LATD6
#define IO_RD6_PORT                 PORTDbits.RD6
#define IO_RD6_ANS                  ANSELDbits.ANSD6
#define IO_RD6_SetHigh()            do { LATDbits.LATD6 = 1; } while(0)
#define IO_RD6_SetLow()             do { LATDbits.LATD6 = 0; } while(0)
#define IO_RD6_Toggle()             do { LATDbits.LATD6 = ~LATDbits.LATD6; } while(0)
#define IO_RD6_GetValue()           PORTDbits.RD6
#define IO_RD6_SetDigitalInput()    do { TRISDbits.TRISD6 = 1; } while(0)
#define IO_RD6_SetDigitalOutput()   do { TRISDbits.TRISD6 = 0; } while(0)
#define IO_RD6_SetAnalogMode()      do { ANSELDbits.ANSD6 = 1; } while(0)
#define IO_RD6_SetDigitalMode()     do { ANSELDbits.ANSD6 = 0; } while(0)

// get/set IO_RD7 aliases
#define IO_RD7_TRIS                 TRISDbits.TRISD7
#define IO_RD7_LAT                  LATDbits.LATD7
#define IO_RD7_PORT                 PORTDbits.RD7
#define IO_RD7_ANS                  ANSELDbits.ANSD7
#define IO_RD7_SetHigh()            do { LATDbits.LATD7 = 1; } while(0)
#define IO_RD7_SetLow()             do { LATDbits.LATD7 = 0; } while(0)
#define IO_RD7_Toggle()             do { LATDbits.LATD7 = ~LATDbits.LATD7; } while(0)
#define IO_RD7_GetValue()           PORTDbits.RD7
#define IO_RD7_SetDigitalInput()    do { TRISDbits.TRISD7 = 1; } while(0)
#define IO_RD7_SetDigitalOutput()   do { TRISDbits.TRISD7 = 0; } while(0)
#define IO_RD7_SetAnalogMode()      do { ANSELDbits.ANSD7 = 1; } while(0)
#define IO_RD7_SetDigitalMode()     do { ANSELDbits.ANSD7 = 0; } while(0)

// get/set LCD_RS aliases
#define LCD_RS_TRIS                 TRISEbits.TRISE0
#define LCD_RS_LAT                  LATEbits.LATE0
#define LCD_RS_PORT                 PORTEbits.RE0
#define LCD_RS_ANS                  ANSELEbits.ANSE0
#define LCD_RS_SetHigh()            do { LATEbits.LATE0 = 1; } while(0)
#define LCD_RS_SetLow()             do { LATEbits.LATE0 = 0; } while(0)
#define LCD_RS_Toggle()             do { LATEbits.LATE0 = ~LATEbits.LATE0; } while(0)
#define LCD_RS_GetValue()           PORTEbits.RE0
#define LCD_RS_SetDigitalInput()    do { TRISEbits.TRISE0 = 1; } while(0)
#define LCD_RS_SetDigitalOutput()   do { TRISEbits.TRISE0 = 0; } while(0)
#define LCD_RS_SetAnalogMode()      do { ANSELEbits.ANSE0 = 1; } while(0)
#define LCD_RS_SetDigitalMode()     do { ANSELEbits.ANSE0 = 0; } while(0)

// get/set LCD_RW aliases
#define LCD_RW_TRIS                 TRISEbits.TRISE1
#define LCD_RW_LAT                  LATEbits.LATE1
#define LCD_RW_PORT                 PORTEbits.RE1
#define LCD_RW_ANS                  ANSELEbits.ANSE1
#define LCD_RW_SetHigh()            do { LATEbits.LATE1 = 1; } while(0)
#define LCD_RW_SetLow()             do { LATEbits.LATE1 = 0; } while(0)
#define LCD_RW_Toggle()             do { LATEbits.LATE1 = ~LATEbits.LATE1; } while(0)
#define LCD_RW_GetValue()           PORTEbits.RE1
#define LCD_RW_SetDigitalInput()    do { TRISEbits.TRISE1 = 1; } while(0)
#define LCD_RW_SetDigitalOutput()   do { TRISEbits.TRISE1 = 0; } while(0)
#define LCD_RW_SetAnalogMode()      do { ANSELEbits.ANSE1 = 1; } while(0)
#define LCD_RW_SetDigitalMode()     do { ANSELEbits.ANSE1 = 0; } while(0)

// get/set LCD_E aliases
#define LCD_E_TRIS                 TRISEbits.TRISE2
#define LCD_E_LAT                  LATEbits.LATE2
#define LCD_E_PORT                 PORTEbits.RE2
#define LCD_E_ANS                  ANSELEbits.ANSE2
#define LCD_E_SetHigh()            do { LATEbits.LATE2 = 1; } while(0)
#define LCD_E_SetLow()             do { LATEbits.LATE2 = 0; } while(0)
#define LCD_E_Toggle()             do { LATEbits.LATE2 = ~LATEbits.LATE2; } while(0)
#define LCD_E_GetValue()           PORTEbits.RE2
#define LCD_E_SetDigitalInput()    do { TRISEbits.TRISE2 = 1; } while(0)
#define LCD_E_SetDigitalOutput()   do { TRISEbits.TRISE2 = 0; } while(0)
#define LCD_E_SetAnalogMode()      do { ANSELEbits.ANSE2 = 1; } while(0)
#define LCD_E_SetDigitalMode()     do { ANSELEbits.ANSE2 = 0; } while(0)

/**
   @Param
    none
   @Returns
    none
   @Description
    GPIO and peripheral I/O initialization
   @Example
    PIN_MANAGER_Initialize();
 */
void PIN_MANAGER_Initialize (void);

/**
 * @Param
    none
 * @Returns
    none
 * @Description
    Interrupt on Change Handling routine
 * @Example
    PIN_MANAGER_IOC();
 */
void PIN_MANAGER_IOC(void);



#endif // PIN_MANAGER_H
/**
 End of File
*/